//************************************************************************************//
// Module       : gkeygen.cpp
// Date         : 8/25/03 (DLR)
// Copyright    : 2003-2006 Copyright University Corporation for Atmospheric
//                Research
// Description  : Encapsulates the access methods and data associated with
//                defining a key-generator, as used in GASpAR. This class is
//                intended to be a abstract base class for defined GKeyGen
//                objects
// Derived From : none.
// Modifications:
//************************************************************************************//
#if !defined(GKEYGEN_HPP)
#define GKEYGEN_HPP

#include "gtypes.h"
#include "point.hpp"
#include <iostream.h>
#include <stdlib.h>

class GKeyGen
{
public:

                           GKeyGen();
                          ~GKeyGen();

virtual  void              key(void *id, GINT idsz, Point3D point[], GINT  n=1)=0;    // Get key/id data
virtual  void              key(void *id, GINT idsz, GDOUBLE   *x   [], GINT  n=1)=0;  // Get key/id data



private:

         // Member data:
};

#endif
