//************************************************************************************//
// Module       : identityop.hpp
// Date         : 6/4/02 (DLR)
// Copyright    : 2002-2006 Copyright University Corporation for Atmospheric
//                Research
// Description  : Encapsulates the methods and data associated with
//                the identity operator
// Derived From : LinOp.
// Modifications:
//************************************************************************************//
#include "identityop.hpp"


//************************************************************************************
//************************************************************************************
// Constructor Method (1)
IdentityOp::IdentityOp()
: LinOp() 
{
} // end of constructor method (1)


//************************************************************************************
//************************************************************************************
// Destructor
IdentityOp::~IdentityOp()
{
}

//************************************************************************************
//************************************************************************************
// METHOD     : Multiplication operation
// DESCRIPTION: Multiplies operator by right hand vector
// RETURNS    :  

GVector  IdentityOp::operator*(GVector q) 
{
  GIndex   sei=q.GetIndex();
  GVector  newq(sei);

  newq = q;


  return newq;

} // end of method oerator * (vector)


