//************************************************************************************//
// Module       : guser_nwave_test.h
// Copyright    : 2005-2006 Copyright University Corporation for Atmospheric
//                Research
//************************************************************************************//
//############################################################################################
//############################################################################################
//                                  GASpAR user header file:
//############################################################################################
//############################################################################################


#if defined(_GASPAR_H_INIT)
GBOOL          bFileWrite= TRUE;
GDOUBLE        t0    = 0.01;
GDOUBLE        R0    = 1000.0;
GDOUBLE        A     = 1.0;
GDOUBLE        kx    = 1.0;
GDOUBLE        ky    = 1.0;
GDOUBLE        gdUL2 = 0.0;
GDOUBLE        gL_ [GDIM];
Point          rho0       ;
GFieldList     u1a        ;
GFieldList     u2a        ; 
GFieldList     ke         ; 
GFieldList     kea        ; 
#else
extern GBOOL          bFileWrite;
extern GDOUBLE        t0    ;
extern GDOUBLE        R0    ;
extern GDOUBLE        A     ;
extern GDOUBLE        kx    ;
extern GDOUBLE        ky    ;
extern GDOUBLE        gdUL2 ;
extern GDOUBLE        gL_ [];
extern Point          rho0  ;
extern GFieldList     u1a   ;
extern GFieldList     u2a   ;
extern GFieldList     ke    ;
extern GFieldList     kea   ;
#endif
void NWave   (GDOUBLE &ux, GDOUBLE &uy, GDOUBLE x, GDOUBLE y, GDOUBLE t, GBOOL bplanar);
void PlNWave (GDOUBLE &ux, GDOUBLE x, GDOUBLE y, GDOUBLE t);
void PNWave  (GDOUBLE &ux, GDOUBLE &uy, GDOUBLE x, GDOUBLE y, GDOUBLE t);
void RegisterMyFields();
void SetMyParams();
GBOOL DoCompare(const char *);

//############################################################################################
//############################################################################################


